        section ABC_kbd
* Connect IBM-keyboard to QL
* written by Jochen Merz for ABC-Elektronik
* adapted by Tony Tebby
* just about totally rewritten by LWR

*----------------------------*
* embedded include file data *
*----------------------------*

*       include 'win1_m_inc_vect'
bp.init equ     $110
ca.gtlin equ    $118
ca.gtstr equ    $116
io.qin  equ     $E0
io.qout equ     $E2
io.qset equ     $DC
io.qtest equ    $DE
ip.kbend equ    $152
ip.kbrd equ     $150

*       include 'win1_m_inc_err'
err.bp  equ     -15

*       include 'win1_m_inc_mt'
mt.alchp equ    $18
mt.inf  equ     0
mt.ipcom equ    $11
mt.lpoll equ    $1C
mt.lxint equ    $1A

*       include 'win1_m_inc_q'
q_queue equ     $10

*       include 'win1_m_inc_sv'
sv_arbuf equ    $8A
sv_chtop equ    $7C
sv_i2lst equ    $38
sv_keyq equ     $4C
sv_lxint equ    $00

*       include 'win1_m_inc_sx'
sx_ipcom equ    $14

*       include 'win1_m_inc_assert'
assert macro
i setnum 1
l maclab
i setnum [i]+1
 ifnum [i] > [.nparms] goto x
 ifnum [.parm([i]-1)] = [.parm([i])] goto l
        error   [.parm([i]-1)] is not [.parm([i])]
x maclab
 endm

*-------------------*
* Hardware adresses *
*-------------------*

* h.ff    equ     $BFBE   keyboard flip-flop (confuses the keyboard?)

h.data  equ     $BFBD   keyboard 8 bit data
h..up   equ     0       keyb-up bit (BEFORE bit reversal)

h.clstr equ     $BFBB   keyboard clear strobe

h.strob equ     $BFB7   keyboard strobe read
h..st   equ     5       strobe bit

*----------------------------------*
* (pseudo) device definition block *
*----------------------------------*

kb_ipcm equ     -8    2 longs   link into MT.IPCOM
* two longwords external interrupt linkage
* two longwords poll loop linkage
* two longwords sheduler loop linkage (not used at present)
* four longwords driver linkage (not used at present)
* spare equ     $28   6 bytes
kb_keyrw equ    $2E     byte    IPC KEYROW enable (lsb 0=no, 1=yes)
kb_krwem equ    $2F  11 bytes   KEYROW emulation table
kb_slug equ     $3A     word    processor slow-down factor
kb_name equ     $3C   5 bytes   word (3) + 'ABC' at standard offset
kb_hotk equ     $41     byte    PRTSC character '/'
kb_queue equ    $42             keyboard interrupt queue
kb.queln equ    21              length of keyboard queue
kbd_end equ     kb_queue+q_queue+kb.queln+1

kb_shf  equ     kb_krwem+7      byte holding status of shift keys
kb..shf equ     0       shift   (combined SHIFT keys here)
kb..ctl equ     1       CTRL
kb..alt equ     2       ALT

kb_flgs equ     kb_krwem+10     extended KEYROW emulation flags:
kb..lsh equ     3       left SHIFT key
kb..rsh equ     4       right SHIFT key
* spare equ     5
kb..num equ     6       NumLock togle
kb..ipc equ     7       flag when nesting

* Encoder shift masks
e.alt   equ     1
e.ctl   equ     2
e.shf   equ     4

*-------------------------*
* General keyboard layout *
*-------------------------*

* (a phantom key?)

*  +---+
*  |00 |
*  |SYS|
*  |REQ|
*  +---+

* Main keyboard

*  +---+---+---+---+---+---+---+---+---+---+---+---+---+------+-------+-------+
*  |01 |02 |03 |04 |05 |06 |07 |08 |09 |10 |11 |12 |13 |14    |69     |70     |
*  |  | ! | @ | # | $ | % | ^ | & | * | ( | ) | _ | + | /___ |  NUM  | SCROLL|
*  |ESC| 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 0 | - | = | \    |  LOCK |  LOCK |
*  +---+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+--+---+---+---+---+---+
*  |15   |16 |17 |18 |19 |20 |21 |22 |23 |24 |25 |26 |27  |28 |71 |72 |73 |74 |
*  | TAB | Q | W | E | R | T | Y | U | I | O | P | { |  } |   | 7 | 8 | 9 | - |
*  |     |   |   |   |   |   |   |   |   |   |   | [ |  ] |  ||HME| /\|PUP| _ |
*  +-----++--++--++--++--++--++--++--++--++--++--++--++---+  |+---+---+---+---+
*  |29    |30 |31 |32 |33 |34 |35 |36 |37 |38 |39 |40 |41 | /||75 |76 |77 |78 |
*  | CTRL | A | S | D | F | G | H | J | K | L | : | " | ~ |<-'| 4 | 5 | 6 | | |
*  |      |   |   |   |   |   |   |   |   |   | ; | ' | ` | \ |<--|   |-->|-+-|
*  +----+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+---+---+---+---+---+ | +
*  |42  |43 |44 |45 |46 |47 |48 |49 |50 |51 |52 |53 |54   |55 |79 |80 |81 |   |
*  |//\\| | | Z | X | C | V | B | N | M | < | > | ? | //\\| * | 1 | 2 | 3 | E |
*  | || | \ |   |   |   |   |   |   |   | , | . | / |  || |PRT|END| \/|PDN| N |
*  +----+-+-+---+---+---+---+---+---+---+---+---+-+-+-----+---+---+---+---+ T +
*  |56    |57                                     |58     |82     |83     | E |
*  |  ALT |                                       |  CAPS |   0   |   .   | R |
*  |      |                                       |  LOCK |  INS  |  DEL  |   |
*  +------+---------------------------------------+-------+-------+-------+---+

* Function keys

*  +---+---+ +--. .
*  |59 |60 | |01. .
*  | F1| F2| |  . .
*  |   |   | |ESC. .
*  +---+---+ +---. .
*  |61 |62 | |15  . .
*  | F3| F4| | TAB . .
*  |   |   | |     . .
*  +---+---+ +----. .
*  |63 |64 | |29   . .
*  | F5| F6| | CTRL. .
*  |   |   | |    . .
*  +---+---+ +---. .
*  |65 |66 | |42 . .
*  | F7| F8| |//\\. .
*  |   |   | | || . .
*  +---+---+ +---. .
*  |67 |68 | |56. .
*  | F9|F10| | . .
*  |   |   | | . .
*  +---+---+ +. .

*----------------------*
* Extended KEYROW data *
*----------------------*

* As well as the standard eight rows of KEYROW data, the following are also
* accessable:

* column    1       2       4       8       16      32      64     128
* row   +-------+-------+-------+-------+-------+-------+-------+-------+
*       |*  3   |*  0   |*  .   |       |       | always|if set,| always|
*    10 |  PAGE |  INS  |  DEL  | SHIFT | SHIFT |  zero |NUMLOCK|  zero |
*       |  DOWN |       |       | (left)|(right)|(spare)| is on | (used)|
*       +-------+-------+-------+-------+-------+-------+-------+-------+
*       |       |       |*  7   |*  9   |*  -   |*  5   |*  +   |*  1   |
*     9 |  NUM  | SCROLL|  HOME |  PAGE | KEYPAD| KEYPAD| KEYPAD|  END  |
*       |  LOCK |  LOCK |       |   UP  |   _   | space | ENTER |       |
*       +-------+-------+-------+-------+-------+-------+-------+-------+
*       |       |       |*  *   |       |       |       |       |       |
*     8 |  SYS  |  <--  |  PRT  |   F6  |   F7  |   F8  |   F9  |  F10  |
*       |  REQ  |       |   SC  |       |       |       |       |       |
*       +-------+-------+-------+-------+-------+-------+-------+-------+
*       :       :       :       :       :       :       :       :       :
*       +-------+-------+-------+-------+-------+-------+-------+-------+
*       |       |*  4   |*  8   |       |*  6   |       |       |*  2   |
*     1 | ENTER |  left |   up  |  ESC  | right |   \   | space |  down |
*       |       |       |       |       |       |       |       |       |
*       +-------+-------+-------+-------+-------+-------+-------+-------+
*       :       :       :       :       :       :       :       :       :
*       +-------+-------+-------+-------+-------+-------+-------+-------+

* The entries marked with a "*" in the above are all considered to form part of
* the the keypad.
* If NUMLOCK has been used to toggle the NUMLOCK state to on, the upper
* character is transmitted, ignoring SHIFT and CTRL, but prefixed by a
* CHR$(255) if ALT is held.
* If the NUMLOCK state is off, the lower part is transmitted and where this
* already has some shift state inbuilt (e.g. HOME is ALT/left), that shift key
* is ignored, but the rest are incorporated.
* Exceptions to the above are that:
*    1) Keypad keys -, + and PTRSC, when held with CTRL, will slow down,
*       speed up and restore standard speed of the machine, respectively.
*    2) Un-NUMLOCK'ed PRTSC will always send ALT + the HOT_KEY (default "/").
*    3) Un-NUMLOCK'ed INS will always send ALT + ENTER.

*------------*
* Initialise *
*------------*

        moveq   #mt.inf,d0
        trap    #1
        move.l  sv_chtop(a0),a4 get system variable extension address

        moveq   #mt.alchp,d0    allocate psuedo device definition
        moveq   #kbd_end-kb_ipcm,d1
        moveq   #-1,d2
        trap    #1
        tst.l   d0
        bne.s   rts0

        lea     kb_name-kb_ipcm(a0),a2
        addq.w  #3,(a2)+
        move.l  #'ABC/',(a2)+   look a little like a driver and set PRTSC char
        assert  kb_name,kb_hotk-5,kb_queue-6

        moveq   #kb.queln,d1    construct the buffer
        move.w  io.qset,a3
        jsr     (a3)

        move.w  sr,d4
        trap    #0
        or.w    #$700,sr        no interrupt allowed during initialisation

        lea     kbd_ipcm,a1
        lea     sx_ipcom(a4),a2 link into MT.IPCOM list
        move.l  a1,4(a0)
        move.l  (a2),(a0)
        move.l  a0,(a2)

        lea     kbd_xint,a1
        moveq   #mt.lxint,d0    link into external interrupt list
        bsr.s   link

        lea     kbd_poll,a1
        moveq   #mt.lpoll,d0    link into polling loop list
        bsr.s   link

*        lea     h.ff,a1
*        move.b  (a1),d1         do a keyboard reset
*        moveq   #2,d1
*        swap    d1              wait a short while
*kbd_inlp
*        subq.l  #1,d1
*        bne.s   kbd_inlp
*        move.b  (a1),d1b         read data (?) to finish reset
* Old reset did above, new is just the next line:
        move.b  h.clstr,d1      read data (?) to finish reset

        move.w  d4,sr           now let the keyboard interrupt us

        lea     new_comm,a1     link in our extensions
        move.w  bp.init,a2
        jmp     (a2)

link
        addq.l  #8,a0
        move.l  a1,4(a0)
        trap    #1
rts0
        rts

*-----------------------*
* SuperBasic extensions *
*-----------------------*

new_comm
        dc.w    2
        dc.w    hot_key-*
        dc.b    7,'KBD_HOT'
        dc.w    key_row-*
        dc.b    7,'KEY_ROW'
        dc.w    0,0,0

* end of initialisation code, if RAM based, above can be overwritten

*------------------*
* KBD_HOT <string> *
*------------------*

* <string> must be a single character,
* PRTSC, not NUMLOCK'ed, sends an ALT followed by this character.

hot_key
*       moveq   #0,d7           flag in d7 (always zero on entry)
        moveq   #kb_hotk,d5
        move.w  ca.gtstr,a2     get string parameter
        bra.s   key_com

err_bp
        moveq   #err.bp,d0
rts2
        rts

*----------------*
* KEY_ROW <flag> *
*----------------*

* if the flag is even, only ABC keyrows are scanned
* if it is odd, keyrow will OR in the IPC keyrow scan
* now stores full lsb, though bits 7..1 are not (currently!) used

key_row
        moveq   #1,d7           flag, and offset to pick byte
        moveq   #kb_keyrw,d5
        move.w  ca.gtlin,a2     get integer parameter
key_com
        jsr     (a2)
        bne.s   rts2
        add.l   a1,d7
        move.b  2(a6,d7.l),d6   get relevent byte
        sub.l   a1,d7
        bne.s   lenok
        cmp.w   0(a6,a1.l),d3   is it a genuine one char string for KBD_HOT?
        bne.s   err_bp
lenok
        subq.w  #1,d3
        bne.s   err_bp          must be just one parameter
        assert  0,mt.inf
        trap    #1
        lea     sv_i2lst(a0),a5 get base of external interrupt list
        lea     kbd_xint,a0     this is our routine
fnd_lp
        move.l  (a5),d1         at end of list yet?
        beq.s   err_bp          yes - someone's lost us!
        move.l  d1,a5
        cmp.l   4(a5),a0        is this entry us?
        bne.s   fnd_lp          no - keep looking
        move.b  d6,-sv_lxint(a5,d5.w) yes - set whatever we came here for
        rts

*----------------*
* Various tables *
*----------------*

* Keyrow Table
* bits 6..3 = row, bits 2..0 = col (bit number)

row_tab

i.sys   equ     *-row_tab
        dc.b    @100,@13         0  2   SYSREQ ESC
i.svn   equ     *-1+7-row_tab
        dc.b    @43,@61,@41,@06,@02,@62,@07,@60,@50,@65 123467890
        dc.b    @55,@35         12 13   -=
i.clf   equ     *-row_tab
        dc.b    @101            14      <--

        dc.b    @53             15      TAB
        dc.b    @63,@51,@64,@54,@66,@56,@67,@52,@57,@45 qwertyuiop
        dc.b    @30,@20,@10     26 28   obr ] ENTER

i.ctl   equ     *-row_tab
        dc.b    @71             29      CTRL
        dc.b    @44,@33,@46,@34,@36,@42,@47,@32,@40 asdfghjkl
        dc.b    @37,@27,@25     39 41   ;'`

i.lsh   equ     *-row_tab
        dc.b    @120+kb..lsh    42      left SHIFT key
        dc.b    @15,@21,@73,@23,@74,@24,@76,@26 zxcvbnm
        dc.b    @77,@22,@75     51 53   ,./
i.rsh   equ     *-row_tab
        dc.b    @120+kb..rsh    54      right SHIFT key
i.prt   equ     *-row_tab
        dc.b    @102            55      PRTSC
i.alt   equ     *-row_tab
        dc.b    @72             56      ALT
        dc.b    @16,@31         57 58   space CAPSLOCK
f1_f5
        dc.b    @01,@03,@04,@00,@05     F1-F5
i.f6    equ     *-row_tab
        dc.b    @103,@104,@105,@106,@107 F6-F10

i.num   equ     *-row_tab
        dc.b    @110,@111       69 70   NUMLOCK FREEZE
i.scr   equ     *-1-row_tab

i.kp0   equ     *-row_tab
        dc.b    @112,@12,@113,@114 74   KP7 u/KP8   KP9 KP-
i.kpm   equ     *-1-row_tab
        dc.b    @11,@115,@14,@116  78 l/KP4   KP5 r/KP6 KP+
i.kpp   equ     *-1-row_tab
        dc.b    @117,@17,@120   79 81   KP1 d/KP2   KP3
        dc.b    @121,@122       82 83       i/KP0       KP.
i.inv   equ     *-row_tab

* Special keys jump table
* a1 points here prior to table lookup
* N.B. reverse numeric order for keys, as we drop out at key > table entry
e setstr svn    lock in the first jmp point to get table built properly
y setstr inv
jtab macro x
        assert  0,(i.[y]-i.[x])&256
y setstr [x]
        dc.b    (exk_[x]-exk_[e]+gt_[e]-*-2)>>1,i.[x]
 endm

exk_top ds.w    0
        jtab    scr     SCROLL LOCK - change to CTRL/ALT/TAB
gt_scr
        jtab    num     NUM LOCK - toggle state
        jtab    alt     ALT - no further action
gt_alt
        jtab    prt     PRTSC - ALT/hotkey or, if NUMLOCK, '*'
        jtab    rsh     right SHIFT - set joint shift
        jtab    lsh     left SHIFT - set joint shift
        jtab    ctl     CTRL key - no further action
        jtab    clf     force <-- to always be CTRL/left
        jtab    [e]     if needed, simulate CTRL/ALT/7
gt_[e]
        jtab    sys     SYSREQ - do queue switch (key not present!?!)

kp_unlk
        dc.b    @111,@120,@124,@354  HOME  up     PGUP   underscore
        dc.b    @110,@160,@140,@100  left  space  right  ENTER
        dc.b    @141,@170,@174       END   down   PGDN
        dc.b    @101,@142            INS   DEL
* The above have their ls octal digit "or"'ed into the shifts, then the rest is
* shifted down, and bit 4 cleared, to give the keyrow code.

kp_lock
        dc.b    '789-'
        dc.b    '456+'
        dc.b    '123'
        dc.b    '0.'

*-------------------------------*
* key handling code starts here *
*-------------------------------*

exk_[e] ds.w    0               (this is needed as the first jmp point)
        pea     encode
        cmp.b   #e.ctl!e.alt,d2 is it CTRL/ALT/7?
        bne.s   rts3            no - let it go
* Simulate a level 7 interrupt (not very well, as it fails to mess up the IPC!)
        move    sr,-(sp)
        or.w    #$700,sr
        move.l  $7C,-(sp)
rts3
        rts

exk_lsh
exk_rsh
        assert  0,kb..shf
        bset    d1,(a3)         set joint SHIFT key flag
        bra.s   nxt1            no further action

exk_num
        assert  6,kb..num
        assert  kb_flgs,kb_slug-1
        bchg    d6,-(a2)        toggle NUMLOCK
        bra.s   nxt1            that's all

exk_sys
        moveq   #@10,d0         change SYSREQ to look like CTRL/ALT/ENTER
        bra.s   ctlalt

exk_scr
        moveq   #@53,d0         SCROLL LOCK - change to CTRL/ALT/TAB
ctlalt
        moveq   #e.ctl!e.alt,d2
        bra.s   encode

slower
        addq.w  #8,(a2)         increase the slug factor
        bcc.s   nxt1
        subq.w  #8,(a2)         this'll do...
faster
        subq.w  #1,(a2)         decrease the slug factor (lower for fine tune)
        bcc.s   nxt1
setslug
        clr.w   (a2)            clear the slug factor to zero
nxt1
        bra.s   next

exk_prt
        assert  2,e.ctl 
        cmp.b   d5,d2           is it just CTRL/PRTSC?
        beq.s   setslug         yes - go clear out the slug factor

        move.b  kb_hotk(a5),d1  normally PRTSC gives ALT/hotkey
        assert  6,kb..num
        assert  kb_flgs,kb_slug-1
        btst    d6,-(a2)
        beq.s   alt_it          no NUMLOCK, so go add ALT
        moveq   #'*',d1         if NUMLOCK, PRTSC gives "*"
qalt
        lsr.b   #1,d2           only take notice of ALT
        bcc.s   force
alt_it
        lsl.w   #8,d1
        st      d1

* The following is a bit of a fudge, as I failed to allow a direct call
force
        move.w  #16,a0
*ip_kbrd
        clr.w   SV_ARBUF(A6)    get rid of previous auto repeat
        move.l  SV_CHTOP(A6),A4 get sysvar extension
*        move.l  SX_KBENC(A4),A3 get encoder address
*        jsr     (A3)            call encoder via vector table
*        bra.s   SPECIAL         special processing return
*        bra.s   KB_INCH         put it into the queue
        bra.s   add_kbrd

key_pad
        assert  2,e.ctl 
        cmp.b   d5,d2           have we got just CTRL on?
        bne.s   notpm           no - leave that
        subq.b  #i.kpm-i.kp0,d4 is it CTRL/-?
        beq.s   slower          yes - go slow down
        subq.b  #i.kpp-i.kpm,d4 is it CTRL/+?
        beq.s   faster          yes - go speed up
        addq.b  #i.kpp-i.kp0,d4
notpm
        move.b  kp_unlk-gt_scr(a1,d4.w),d0 code for un-NUMLOCK'ed keypad
        assert  6,kb..num
        assert  kb_flgs,kb_slug-1
        btst    d6,-(a2)
        beq.s   augment
        move.b  kp_lock-gt_scr(a1,d4.w),d1 forced byte for NUMLOCK'ed keypad
        bra.s   qalt            go handle NUMLOCK'ed keypad, ALT may be added

exk_clf
        moveq   #@112,d0        force <- key to always behave as CTRL/left
augment
        or.b    d0,d2           ls 3 bits augment shift states
        asr.b   #3,d0
        bclr    #4,d0           change @75 to @55 for underscore
        bra.s   encode

exk_ok
        assert  1<<6,i.f6
        bclr    d6,d4           "and"'s with 63, in effect
        beq.s   encode          normal keys are less than F6
        subq.w  #i.kp0-i.f6,d4  check for F6-F10 (NUM/SCROLL done)
        bcc.s   key_pad         go do keypad
        assert  1<<2,e.shf
        bset    d5,d2           force them to be SHIFT'ed
        move.b  i.kp0-i.f6+f1_f5-gt_alt(a1,d4.w),d0 replace F6-F10 with F1-F5
encode
        eor.b   d0,d1           encode rows go backwards!
        sub.l   a0,a0
add_kbrd
        add.w   ip.kbrd,a0
        bsr.s   jsr4000
        bra.s   next

row_clr
        bclr    d0,kb_krwem(a5,d3.w)
        moveq   #1<<kb..lsh!1<<kb..rsh,d6
        assert  kb_flgs,kb_slug-1
        and.b   -(a2),d6        are both SHIFT keys now up?
        bne.s   next            no - carry on
        assert  0,kb..shf
        bclr    d1,(a3)         yes - clear joint SHIFT flag

exk_ctl
exk_alt
next
        lea     exk_top,a1      set up our table pointer
        moveq   #2,d5           useful constant
        moveq   #6,d6           another useful constant
        assert  0,h..up
        moveq   #1<<6,d4        reverse all but h..up bit
        move.w  io.qout,a0
        bsr.s   do_io
        subq.l  #kb_queue-kb_slug,a2 useful pointer
        lea     kb_shf(a5),a3   another useful pointer
        bne.s   endup           on error, go finish off, otherwise d0.l=0

brev
        add.b   d1,d1
        roxr.b  #1,d4
        bcc.s   brev            reverse bits 7..1
        lsr.b   #1,d4           final bit for keyscan number is zero
        cmp.b   #i.inv,d4       keys 84+ are invalid!
        bcc.s   next

        move.b  row_tab-exk_top(a1,d4.w),d0 get keyrow info

        move.w  d0,d3
        lsr.b   #3,d3           row number

        add.b   d1,d1           test h..up bit (d1.b now zero)
        bcs.s   row_clr         if set, key has been released
        moveq   #@70,d1         invert rows at encode, msb's 0, btst #0, etc.,.

        bset    d0,kb_krwem(a5,d3.w)

        assert  0,1<<kb..shf-e.alt,1<<kb..ctl-e.ctl,1<<kb..alt-e.shf
        moveq   #256>>3,d2      three bits to reverse, set marker & msb's 0
        move.b  (a3),d3         get current shift state
srev
        asr.b   #1,d3
        addx.b  d2,d2           reverse shift bits
        bcc.s   srev
exk_lp
        move.w  (a1)+,d3
        cmp.b   d3,d4
        bcs.s   exk_lp          loop until table code <= this code
        bne.s   exk_ok          not found, so go do general stuff
        lsr.w   #7,d3
        jmp     exk_[e]-gt_[e](a1,d3.w) go do key with special processing

* no (more) keys at the moment
endup
        move.w  ip.kbend,a0     finish off (d5 bit 4 is zero, no key held)
jsr4000
        move.l  sv_keyq(a6),d0  fetch ptr to current keyboard queue
        beq.s   rts9            no queue, don't bother with this
        move.l  d0,a2
        jmp     $4000(a0)

*---------------*
* keyboard poll *
*---------------*

* I have kept d7 spare, so we can probably easily go over to the ROM version of
* auto-repeat keys, if needed.
* What is required is to swap over usage of d5 and d7 throughout, ignore
* repeated "held down" keys, and, if the last such was sent out at "add_kbd"
* above, call "kbend" with d5 bit 4 set. Also d3 must be preserved!

kbd_poll
* do poll loop slugging
        moveq   #0,d0
slugit
        move.w  io.qtest,a0
        addq.w  #1,d0
        cmp.w   kb_slug(a3),d0
        bcs.s   slugit          repeat extra code so slug is slow!
        bsr.s   do_io1
        beq.s   next            only enter main loop if we have a keyscan
        rts

*----------------------------*
* External interrupt routine *
*----------------------------*

kbd_xint
        lea     h.strob,a1
        move.b  (a1),d0         check whether a key has been pressed
        lsl.b   #8-h..st,d0
        bcs.s   rts9            no key has been pressed or released
        move.b  h.data-h.strob(a1),d1 get key-code
        move.b  h.clstr-h.strob(a1),d0 and clear strobe
        move.w  io.qin,a0       put code into buffer
do_io1
        move.l  a3,a5           set safe place for definition block pointer
do_io
        lea     kb_queue(a5),a2
        jmp     (a0)

*------------------------------*
* MT.IPCOM intercept of KEYROW *
*------------------------------*

* Rats! I forgot to provide vector and code to do the IPC keyrow read here.
* We need to "or" together ABC with IPC to catch joystick reads.
* Though it's tacky, we nest down another IPCOM call to read the IPC.

kbd_ipcm
        cmp.b   #9,d0           is it KEYROW read
        bne.s   rts9            no, leave it to the experts!
        assert  7,kb..ipc
        tas     kb_flgs-kb_ipcm(a0) are we doing our dirty nesting?
        bmi.s   rts9            yes, don't get any deeper!

        move.l  a3,a1
        add.l   d5,d5
findlp
        addq.l  #1,a1
        lsr.l   #2,d5
        bcs.s   findlp          find the right parameter byte for row number
        moveq   #15,d5
        and.b   -(a1),d5

        moveq   #0,d1
        moveq   #7,d6
        cmp.b   d5,d6           will the IPC understand this row number?
        bcs.s   keyrow_us       no - don't bother with it

        btst    d1,kb_keyrw-kb_ipcm(a0) is IPC-KEYROW selected?
        beq.s   keyrow_us       no - just do our bit

        subq.l  #6,a3           put a3 back to normal position
        moveq   #mt.ipcom,d0
        trap    #1              nest down .... real tacky, but ... it works...
keyrow_us
        bclr    d6,kb_flgs-kb_ipcm(a0) clear our nest flag
        or.b    kb_krwem-kb_ipcm(a0,d5.w),d1 add our keyrow, to ql or nothing
        addq.l  #2,(sp)         we have processed the command
rts9
        rts

        end
